c +++ target ++++++++++++++++++++++++++++++++++++++++++++++++



      subroutine target_def
      implicit NONE
c local 
      real point(3), v1(3), v2(3), width(3), u(3), Rin, Rout
      integer l_He /32/,  Al /39/, STP /-1/, SUS /43/, CH /49/
	integer BC412 /60/
	real target_thickness, frame_thickness, window_thickness
	character*8 m_title 
	integer C/35/, CFRP /70/, Maylar/55/, Air /57/, Be/34/, Fe/43/
	real gcm3
c common
c ... common for setup
c	neutron counters
	integer n_start, n_end
	common /ncount/ n_start, n_end
c	neutron veto counters
	integer ncv_start, ncv_end
	common /ncv/ ncv_start, ncv_end
c 	TC
	common /TC/ TC_up, TC_down
	integer TC_up, TC_down
c	veto counters
	common /vetoc/ VDC_VETO_start, VDC_VETO_end, BDC_VETO_start, BDC_VETO_end
	integer VDC_VETO_start, VDC_VETO_end, BDC_VETO_start, BDC_VETO_end
c	boundary
	integer b_start, b_end
	common /boundary/ b_start, b_end
c	target
	common /trg/ target_center, tm, tta, tc
	real target_center, tm, tta, tc
c ... common /DIRS/ for save directory name
	character*80 DirSave
	integer DirL
	common /DIRS/ DirSave, DirL
c added local
	real target_offset_x, target_offset_y, target_offset_z
	real heat_shield_offset_z, vaccuum_vessel_offset_z
	real cell_zy_angle, z_len, d_y, d_z
c
	target_offset_x = -0.30	! from sato
	target_offset_y = -0.30	! from sato
	target_offset_z = -0.70	! from sato
	cell_zy_angle = 0.04	! from takatoshi
	heat_shield_offset_z = -0.49	! from sato
	vaccuum_vessel_offset_z = +0.1	! from sato
c
      call default_Material
	m_title = 'CFRP'
      call copy_Material(C, CFRP, m_title)
	gcm3 = 2.12
      call change_density(CFRP, gcm3)
	gcm3 = 0.145
      call change_density(l_He, gcm3)
      call Define_Space(Air, 1, 1)
c
      v1(1) = 1.
      v1(2) = 0.
      v1(3) = 0.
      v2(1) = 0.
      v2(2) = 1.
      v2(3) = 0.
	target_thickness = 6.
	window_thickness = 0.0075
	frame_thickness = 0.06
	target_center = 1.1
c carbon degrader @ -66.4 ~ -26
      width(1) = 20.
      width(2) = 20.
      width(3) = 40.4
      point(1) = 0.
      point(2) = 0.
      point(3) = - 26. - 40.4/2.
      call define_Cube(37,point,v1,v2,width,C,1,1)
c T0 @ -26 ~ -25
      width(1) = 16.
      width(2) = 16.
      width(3) = 1.
      point(1) = 0.
      point(2) = 0.
      point(3) = -25.5
      call define_Cube(1,point,v1,v2,width,BC412,1,1)
c BDC exit window @ -14.45 ~ -14.55
      width(1) = 16.
      width(2) = 16.
      width(3) = 0.1
      point(1) = 0.
      point(2) = 0.
      point(3) = -14.5 
      call define_Cube(2,point,v1,v2,width,Air,1,1)
c liquid target @ -4.4 ~ 10.6 = 3.1 +- 7.5
      point(1) = 0. + target_offset_x
      point(2) = 0. + target_offset_y
	tm = 2.1
	tta = 9.
c	tm = 0.
c	tta = 0.
      point(3) = target_center + tm + target_offset_z
      tc = point(3) ! 1.1 + 2.1 = 3.2 cm -> 2.49 (to downstream)
	Rin = 0.
	Rout = 11.75
      u(1) = 0.
      u(2) = 0.
      u(3) = (target_thickness + tta)/2. 	! 6.0 + 9.0 = 15,0 cm
      u(2) = cell_zy_angle * u(3) 
      u(3) = sqrt(1. - cell_zy_angle**2) * u(3) 
      call define_Cylinder(3,point,u,Rin,Rout,l_He,1,1)
c maylar target cell windows
      u(1) = 0.
      u(2) = 0.
      u(3) = window_thickness / 2.
      u(2) = cell_zy_angle * u(3) 
      u(3) = sqrt(1. - cell_zy_angle**2) * u(3) 
      point(1) = 0. + target_offset_x
      point(2) = 0. + target_offset_y
      point(3) = (target_thickness + tta + window_thickness) / 2.
     &	 + target_center + tm + target_offset_z
	z_len = point(3) - tc
	d_y = cell_zy_angle * z_len
	d_z = (1.-sqrt(1. - cell_zy_angle**2)) * z_len
      point(2) = point(2) + d_y
      point(3) = point(3) + d_z
	Rin = 0.
	Rout = 10.
      call define_Cylinder(4,point,u,Rin,Rout,Maylar,1,1)
      point(1) = 0. + target_offset_x
      point(2) = 0. + target_offset_y
      point(3) = -(target_thickness + tta + window_thickness) / 2.
     &	 + target_center + tm + target_offset_z
	z_len = point(3) - tc
	d_y = cell_zy_angle * z_len
	d_z = (1.-sqrt(1. - cell_zy_angle**2)) * z_len
      point(2) = point(2) + d_y
      point(3) = point(3) + d_z
      call define_Cylinder(5,point,u,Rin,Rout,Maylar,1,1)
c aluminum target cell frame
	Rin = 11.75
	Rout = 11.75 + frame_thickness
      point(1) = 0. + target_offset_x
      point(2) = 0. + target_offset_y
      point(3) = tc
	z_len = point(3) - tc
	d_y = cell_zy_angle * z_len
	d_z = (1.-sqrt(1. - cell_zy_angle**2)) * z_len
      point(2) = point(2) + d_y
      point(3) = point(3) + d_z
      u(1) = 0.
      u(2) = 0.
      u(3) = (target_thickness + tta)/2. 
      u(2) = cell_zy_angle * u(3) 
      u(3) = sqrt(1. - cell_zy_angle**2) * u(3) 
      call define_Cylinder(6,point,u,Rin,Rout,Al,1,1)
	Rin = 10.
	Rout = 11.75
      u(1) = 0.
      u(2) = 0.
      u(3) = frame_thickness / 2.
      u(2) = cell_zy_angle * u(3) 
      u(3) = sqrt(1. - cell_zy_angle**2) * u(3) 
      point(1) = 0. + target_offset_x
      point(2) = 0. + target_offset_y
      point(3) = (target_thickness + tta + frame_thickness) / 2.
     &	 + target_center + tm + target_offset_z
	z_len = point(3) - tc
	d_y = cell_zy_angle * z_len
	d_z = (1.-sqrt(1. - cell_zy_angle**2)) * z_len
      point(2) = point(2) + d_y
      point(3) = point(3) + d_z
      call define_Cylinder(7,point,u,Rin,Rout,Al,1,1)
      point(1) = 0. + target_offset_x
      point(2) = 0. + target_offset_y
      point(3) = -(target_thickness + tta + frame_thickness) / 2.
     &	 + target_center + tm + target_offset_z
	z_len = point(3) - tc
	d_y = cell_zy_angle * z_len
	d_z = (1.-sqrt(1. - cell_zy_angle**2)) * z_len
      point(2) = point(2) + d_y
      point(3) = point(3) + d_z
      call define_Cylinder(8,point,u,Rin,Rout,Al,1,1)
c heat shield
	Rin = 15. - 0.5
	Rout = 15. + 0.02 - 0.5
      point(1) = 0.
      point(2) = 0.
      point(3) = -6.9 + (78.-(10.5-6.9))/2. + heat_shield_offset_z ! -> -7.55 is the center of frame
      u(1) = 0.
      u(2) = 0.
      u(3) = (78.-(10.5-6.9))/2.
      call define_Cylinder(9,point,u,Rin,Rout,Al,1,1)
	Rin = 0.
	Rout = 15. + 0.02 - 0.5
      point(1) = 0.
      point(2) = 0.
      point(3) = -6.9 - 0.02 / 2. + heat_shield_offset_z
      u(1) = 0.
      u(2) = 0.
      u(3) = 0.02 / 2.
      call define_Cylinder(10,point,u,Rin,Rout,Al,1,1)
      point(3) = -6.9 - ( 0.02*2 + 0.3 ) / 2. + heat_shield_offset_z
      u(1) = 0.
      u(2) = 0.
      u(3) = 0.3 / 2.
      call define_Cylinder(41,point,u,Rin,Rout,C,1,1)
c Vaccuum vessel
	Rin = 31.2 / 2. - 0.09
	Rout = 31.2 / 2.
      u(1) = 0.
      u(2) = 0.
      u(3) = 78. / 2.
      point(1) = 0.
      point(2) = 0.
      point(3) = -10.5 + 78. / 2. + vaccuum_vessel_offset_z
      call define_Cylinder(11,point,u,Rin,Rout,CFRP,1,1)
	Rin = 0.
	Rout = 31.2 / 2.
      point(1) = 0.
      point(2) = 0.
      point(3) = -10.5 - 0.06 / 2. + vaccuum_vessel_offset_z
      u(1) = 0.
      u(2) = 0.
      u(3) = 0.06 / 2.
      call define_Cylinder(12,point,u,Rin,Rout,Al,1,1)
c cryostat
	Rin = 35.56 / 2.
	Rout = 45. / 2.
      point(1) = 0.
      point(2) = 0.
      point(3) = -10.5 + 78. + 2./2.
      u(1) = 0.
      u(2) = 0.
      u(3) = 2./2.
      call define_Cylinder(38,point,u,Rin,Rout,Al,1,1)
	Rin = 35.56 / 2. - 0.3
	Rout = 35.56 / 2.
      point(3) = -10.5 + 78. + 2. + 51./2.
      u(3) = 51./2.
      call define_Cylinder(39,point,u,Rin,Rout,Al,1,1)
	Rin = 35.56 / 2.
	Rout = 45. / 2.
      point(3) = -10.5 + 78. + 2. + 51. + 2./2.
      u(3) = 2./2.
      call define_Cylinder(40,point,u,Rin,Rout,C,1,1)
c VDC up trigger
	TC_up = 13
      width(1) = 135.
      width(2) = 0.6
      width(3) = 135.
      point(1) = 0.
      point(2) = 17. + 61.
      point(3) = 0.
      call define_Cube(TC_up,point,v1,v2,width,BC412,1,1)
      width(2) = 2.5
      point(2) = 17. + 61. + (0.6 + 2.5) / 2.
      call define_Cube(TC_up+1,point,v1,v2,width,BC412,1,1)
      width(2) = 0.05
      point(2) = 17. + 61. - 0.3 - 0.1
      call define_Cube(48,point,v1,v2,width,BC412,1,1)
c VDC down trigger
	TC_down = 15
      width(1) = 135.
      width(2) = 0.6
      width(3) = 135.
      point(2) = - (17. + 61.)
      call define_Cube(TC_down,point,v1,v2,width,BC412,1,1)
      width(2) = 2.5
      point(2) = - (17. + 61. + (0.6 + 2.5) / 2.)
      call define_Cube(TC_down+1,point,v1,v2,width,BC412,1,1)
      width(2) = 0.05
      point(2) = -(17. + 61. - 0.3 - 0.1)
      call define_Cube(49,point,v1,v2,width,BC412,1,1)
c floor and bridge
      width(1) = 270.
      width(2) = 1.
      width(3) = 270.
      point(1) = 0.
      point(2) = 150.
      point(3) = 0.
      call define_Cube(50,point,v1,v2,width,Fe,1,1)
      point(2) = -150.
      call define_Cube(51,point,v1,v2,width,Fe,1,1)
c neutron counters
	n_start = 17
	n_end= 18
      width(1) = 35.
      width(2) = 150.
      width(3) = 160.
c      point(1) = 215. + width(1) / 2.
      point(1) = 200. + width(1) / 2.
      point(2) = 0.
      point(3) = 0.
      call define_BOX(17,point,v1,v2,width,STP,0,0)
      point(1) = -point(1)
      call define_BOX(18,point,v1,v2,width,STP,0,0)
c iron converter in front of neutron counters
      width(1) = 0.45
      point(1) = 197.7 
      point(2) = 0.
      point(3) = 0.
      call define_BOX(44,point,v1,v2,width,SUS,0,0)
      point(1) = -point(1)
      call define_BOX(45,point,v1,v2,width,SUS,0,0)
c charged veto for neutron counters
	ncv_start = 46
	ncv_end = 47
      width(1) = 0.6
      point(1) = 195. 
      point(2) = 0.
      point(3) = 0.
      call define_BOX(46,point,v1,v2,width,BC412,0,0)
      point(1) = -point(1)
      call define_BOX(47,point,v1,v2,width,BC412,0,0)
c neutronC suport 
      width(1) = 2.
      width(2) = 150.
      width(3) = 15.
      point(1) = 215. + width(1) / 2. - 20.
      point(2) = 0.
      point(3) = 80. + 10. + 15./2.
      call define_BOX(42,point,v1,v2,width,SUS,0,0)
      point(1) = -point(1)
      call define_BOX(43,point,v1,v2,width,SUS,0,0)
c VDC up Veto
	VDC_VETO_start = 19
      point(1) = 0.
      point(2) = 18.
      point(3) = -29.5
      width(1) = 82.
      width(2) = 0.6
      width(3) = 30.
      call define_Cube(19,point,v1,v2,width,STP,1,1)
      width(1) = 20.
      width(3) = 35.
      point(1) = 31.
      point(3) = 3.
      call define_Cube(20,point,v1,v2,width,STP,1,1)
      point(1) = -31.
      call define_Cube(21,point,v1,v2,width,STP,1,1)
      width(1) = 82.
      width(3) = 30.
      point(1) = 0.
      point(3) = 35.5
      call define_Cube(22,point,v1,v2,width,STP,1,1)
c VDC down Veto
      point(1) = 0.
      point(2) = -18.
      point(3) = -29.5
      width(1) = 82.
      width(2) = 1.
      width(3) = 30.
      call define_Cube(23,point,v1,v2,width,STP,1,1)
      width(1) = 20.
      width(3) = 35.
      point(1) = 31.
      point(3) = 3.
      call define_Cube(24,point,v1,v2,width,STP,1,1)
      point(1) = -31.
      call define_Cube(25,point,v1,v2,width,STP,1,1)
      width(1) = 82.
      width(3) = 30.
      point(1) = 0.
      point(3) = 35.5
      call define_Cube(26,point,v1,v2,width,STP,1,1)
	VDC_VETO_end = 26
c BDC Veto
	BDC_VETO_start = 27
      width(1) = 74.
      width(2) = 9.
      width(3) = 1.
      point(1) = 0.
      point(2) = 9./2. + 8.
      point(3) = -15.6 + target_center - 3.
      call define_Cube(27,point,v1,v2,width,STP,1,1)
      point(2) = -(9./2. + 8.)
      call define_Cube(28,point,v1,v2,width,STP,1,1)
      width(1) = 29.
      width(2) = 16.
      point(1) = 22.5
      point(2) = 0.
      call define_Cube(29,point,v1,v2,width,STP,1,1)
      point(1) = -22.5
      call define_Cube(30,point,v1,v2,width,STP,1,1)
	BDC_VETO_end = 30
c
      call write_Object_tpw(1, 'setup-zy.top', -90., 0., 0., 0, 20.)
	close(1)
      call write_Object_tpw(2, 'setup-tr.top', -135., -45., 20., 0, 20.)
	close(2)
      call write_Object_tpw(3, 'setup-xy.top', 0., -0., 0., 0, 20.)
	close(3)
      call write_Object_tpw(4, 'setup-zx.top', -90., -90., 0., 0, 20.)
	close(4)
c boundary
	b_start = 31
	b_end = 36
      width(1) = 1.
      width(2) = 2000.
      width(3) = 2000.
      point(1) = 300.
      point(2) = 0.
      point(3) = 0.
      call define_BOX(31,point,v1,v2,width,STP,0,0)
      width(1) = 1.
      width(2) = 2000.
      width(3) = 2000.
      point(1) = -300.
      point(2) = 0.
      point(3) = 0.
      call define_BOX(32,point,v1,v2,width,STP,0,0)
      width(1) = 2000.
      width(2) = 1.
      width(3) = 2000.
      point(1) = 0.
      point(2) = 300.
      point(3) = 0.
      call define_BOX(33,point,v1,v2,width,STP,0,0)
      width(1) = 2000.
      width(2) = 1.
      width(3) = 2000.
      point(1) = 0.
      point(2) = -300.
      point(3) = 0.
      call define_BOX(34,point,v1,v2,width,STP,0,0)
      width(1) = 2000.
      width(2) = 2000.
      width(3) = 1.
      point(1) = 0.
      point(2) = 0.
      point(3) = 300.
      call define_BOX(35,point,v1,v2,width,STP,0,0)
      width(1) = 2000.
      width(2) = 2000.
      width(3) = 1.
      point(1) = 0.
      point(2) = 0.
      point(3) = -300.
      call define_BOX(36,point,v1,v2,width,STP,0,0)
      return
      end




